// DHT11 Library (Temperatur- und Luftfeuchtigkeits-Sensor)
// 1.00 - 2017-06-16
// (c) Copyright 2017
//
// Zur Verwendung mit dem Allnet IoT-Brick


#include <DHT.h>


// *** Globale Variablen ***

bool                 DHT11_Inited                      = false;     // Variable für die Initialisierung der DHT11 Benutzung
DHT                  DHT11_Sensor(DHT11_PIN, DHT11);                // Variable vom Typ DHT definieren für Sensortyp DHT11 


// *** Temperatur-Sensor Funktionen ***

void DHT11_Init ()
{
  DHT11_Inited = true;
  DHT11_Sensor.begin();                                             // Sensor initialisieren
}

double DHT11_Temperature ()
{
  if (DHT11_Inited)
  {
    return (DHT11_Sensor.readTemperature());
  }
  else
  {
    return (-127);
  }
}

double DHT11_Humidity ()
{
  if (DHT11_Inited)
  {
    return (DHT11_Sensor.readHumidity());
  }
  else
  {
    return (-127);
  }
}
