// Sound Library
// 1.00 - 2017-06-08
// 1.01 - 2017-11-22
// (c) Copyright 2017
//
// Zur Verwendung mit allen Allnet Libraries

byte snd_GPIO = 13;

// *** Konstanten für Musik-Töne in 8 Oktaven ***

#define snd_Note_B0  31
#define snd_Note_C1  33
#define snd_Note_CS1 35
#define snd_Note_D1  37
#define snd_Note_DS1 39
#define snd_Note_E1  41
#define snd_Note_F1  44
#define snd_Note_FS1 46
#define snd_Note_G1  49
#define snd_Note_GS1 52
#define snd_Note_A1  55
#define snd_Note_AS1 58
#define snd_Note_B1  62
#define snd_Note_C2  65
#define snd_Note_CS2 69
#define snd_Note_D2  73
#define snd_Note_DS2 78
#define snd_Note_E2  82
#define snd_Note_F2  87
#define snd_Note_FS2 93
#define snd_Note_G2  98
#define snd_Note_GS2 104
#define snd_Note_A2  110
#define snd_Note_AS2 117
#define snd_Note_B2  123
#define snd_Note_C3  131
#define snd_Note_CS3 139
#define snd_Note_D3  147
#define snd_Note_DS3 156
#define snd_Note_E3  165
#define snd_Note_F3  175
#define snd_Note_FS3 185
#define snd_Note_G3  196
#define snd_Note_GS3 208
#define snd_Note_A3  220
#define snd_Note_AS3 233
#define snd_Note_B3  247
#define snd_Note_C4  262
#define snd_Note_CS4 277
#define snd_Note_D4  294
#define snd_Note_DS4 311
#define snd_Note_E4  330
#define snd_Note_F4  349
#define snd_Note_FS4 370
#define snd_Note_G4  392
#define snd_Note_GS4 415
#define snd_Note_A4  440
#define snd_Note_AS4 466
#define snd_Note_B4  494
#define snd_Note_C5  523
#define snd_Note_CS5 554
#define snd_Note_D5  587
#define snd_Note_DS5 622
#define snd_Note_E5  659
#define snd_Note_F5  698
#define snd_Note_FS5 740
#define snd_Note_G5  784
#define snd_Note_GS5 831
#define snd_Note_A5  880
#define snd_Note_AS5 932
#define snd_Note_B5  988
#define snd_Note_C6  1047
#define snd_Note_CS6 1109
#define snd_Note_D6  1175
#define snd_Note_DS6 1245
#define snd_Note_E6  1319
#define snd_Note_F6  1397
#define snd_Note_FS6 1480
#define snd_Note_G6  1568
#define snd_Note_GS6 1661
#define snd_Note_A6  1760
#define snd_Note_AS6 1865
#define snd_Note_B6  1976
#define snd_Note_C7  2093
#define snd_Note_CS7 2217
#define snd_Note_D7  2349
#define snd_Note_DS7 2489
#define snd_Note_E7  2637
#define snd_Note_F7  2794
#define snd_Note_FS7 2960
#define snd_Note_G7  3136
#define snd_Note_GS7 3322
#define snd_Note_A7  3520
#define snd_Note_AS7 3729
#define snd_Note_B7  3951
#define snd_Note_C8  4186
#define snd_Note_CS8 4435
#define snd_Note_D8  4699
#define snd_Note_DS8 4978


// *** Sound-Funktionen ***

void snd_Init (byte soundGPIO)
{
  snd_GPIO = soundGPIO;
  #if defined(ESP32)
  #else
    noTone(snd_GPIO);                             // Ggf. bestehende Tonausgabe abschalten
  #endif
  pinMode(snd_GPIO, OUTPUT);                      // GPIO auf Ausgabe schalten
  digitalWrite(snd_GPIO, LOW);                    // GPIO auf 0V schalten
}

void snd_click ()
{
  #if defined(ESP32)
  #else
    tone(snd_GPIO, 1000, 5);                      // Klick erzeugen: 1 kHz Ton für 5 ms.
  #endif
}

void snd_beep ()
{
  #if defined(ESP32)
  #else
    tone(snd_GPIO, 1000, 500);                    // Beep erzeugen: 1 kHz Ton für 500 ms.
  #endif
}

void snd_music (long frequency, long duration, bool synchronous)
{
  if (duration > 0)
  {
    #if defined(ESP32)
    #else
      tone(snd_GPIO, frequency, duration);        // Ton ausgeben (Frequenz in Hz, Dauer in ms.)
    #endif
    if (synchronous)
    {
       delay(duration - 1);
    }
  }
}