// TFT Library (Remote i2c TFT Display)
// 1.00 - 2017-12-19
// (c) Copyright 2017
//
// Zur Verwendung mit allen Allnet Libraries


// *** Globale Variablen der TFT-Library ***

byte lcd_RemoteAddress = 8;


// *** Funktionen der TFT-Library ***

void lcd_RemoteInit ()
{
  #if defined(ESP32)
    IoT_Wire.begin(21, 22, 400000);                             // Externen I2C-Bus starten mit 700 kBit/s.
  #else
    if (!IoT_OLEDinited)
    {
      Wire.begin(400000);                                       // Externen I2C-Bus starten mit 700 kBit/s.
    }
  #endif
}

void lcd_RemotePrintAsc (byte a)
{
  #if defined(ESP32)
    IoT_Wire.beginTransmission(lcd_RemoteAddress);              // Übertragung an LCD-Brick starten
    IoT_Wire.write(a);                                          // Ein Byte senden
    IoT_Wire.endTransmission();                                 // Übertragung an LCD-Brick beenden
  #else
    Wire.beginTransmission(lcd_RemoteAddress);                  // Übertragung an LCD-Brick starten
    Wire.write(a);                                              // Ein Byte senden
    Wire.endTransmission();                                     // Übertragung an LCD-Brick beenden
  #endif
}

void lcd_RemotePrint (String s)
{
  int L = len(s);
  if (L > 0)
  {
    #if defined(ESP32)
      IoT_Wire.beginTransmission(lcd_RemoteAddress);            // Übertragung an LCD-Brick starten
    #else
      Wire.beginTransmission(lcd_RemoteAddress);                // Übertragung an LCD-Brick starten
    #endif
    int count = 2;
    for (int i = 1; i <= L; i ++)
    {
      #if defined(ESP32)
        IoT_Wire.write(indasc(s, i));                           // Ein Byte senden
      #else
        Wire.write(indasc(s, i));                               // Ein Byte senden
      #endif
      count += 1;
      #if defined(ESP32)
        if (count == 29)                                        // Flush Buffer (i2c-Buffer = 31 Zeichen)
        {
          IoT_Wire.endTransmission();                           // Übertragung an LCD-Brick beenden
          delay(count * 2);
          IoT_Wire.beginTransmission(lcd_RemoteAddress);        // Übertragung an LCD-Brick starten
          count = 0;
        }
      #else
          Wire.endTransmission();                               // Übertragung an LCD-Brick beenden
          delay(3);
          Wire.beginTransmission(lcd_RemoteAddress);            // Übertragung an LCD-Brick starten
          count = 0;
      #endif
    }
    count += 2;
    #if defined(ESP32)
      IoT_Wire.endTransmission();                               // Übertragung an LCD-Brick beenden
      delay(count * 2);
    #else
      Wire.endTransmission();                                   // Übertragung an LCD-Brick beenden
      delay(2);
    #endif
  }
}
